---
title: IDBKeyRange.upperBound()
slug: Web/API/IDBKeyRange/upperBound
tags:
  - API
  - Database
  - IDBKeyRange
  - IndexedDB
  - Method
  - Reference
  - Storage
  - upperBound
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>upperBound()</code></strong> method of the {{domxref("IDBKeyRange")}} interface creates a new upper-bound key range. By default, it includes the upper endpoint value and is closed.</p>
</div>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var myIDBKeyRange = IDBKeyRange.upperBound(upper[, open=false])</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><em>bound</em> specifies the upper bound of the new key range.</li>
 <li><em>open </em>indicates whether the upper bound excludes the endpoint value. The default is false. {{optional_inline}}</li>
</ul>

<h3 id="Return_value">Return value</h3>

<p>{{domxref("IDBKeyRange")}}: The newly created key range.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of the following type:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><font face="Courier New, Andale Mono, monospace"><span style="line-height: normal;">DataError</span></font></td>
   <td>
    <p>The value parameter passed was not a valid key.</p>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>The following example illustrates how you'd use an upper bound key range. Here we declare <code>keyRangeValue = IDBKeyRange.upperBound("F");</code> — a range that includes the value "F" and everything before it. We open a transaction (using {{domxref("IDBTransaction")}}) and an object store, and open a Cursor with {{domxref("IDBObjectStore.openCursor")}}, declaring <code>keyRangeValue</code> as its optional key range value. </p>

<p>If we used <code>IDBKeyRange.upperBound("F", true);</code>, then the range excludes "F"; and instead only includes the values before it.</p>

<div class="note">
<p><strong>Note</strong>: For a more complete example allowing you to experiment with key range, have a look at our <a href="https://github.com/mdn/indexeddb-examples/tree/master/idbkeyrange">IDBKeyRange-example</a> repo (<a href="https://mdn.github.io/indexeddb-examples/idbkeyrange/">view the example live too</a>.)</p>
</div>

<pre class="brush: js notranslate" style="font-size: 14px;">function displayData() {
  var keyRangeValue = IDBKeyRange.upperBound("F");

  var transaction = db.transaction(['fThings'], 'readonly');
  var objectStore = transaction.objectStore('fThings');

  objectStore.openCursor(keyRangeValue).onsuccess = function(event) {
    var cursor = event.target.result;
      if(cursor) {
        var listItem = document.createElement('li');
        listItem.innerHTML = '&lt;strong&gt;' + cursor.value.fThing + '&lt;/strong&gt;, ' + cursor.value.fRating;
        list.appendChild(listItem);

        cursor.continue();
      } else {
        console.log('Entries all displayed.');
      }
    };
  };</pre>

<h2 id="Specification"><span style="font-size: 2.14285714285714rem;">Specification</span></h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB 2', '#dom-idbkeyrange-upperbound-upper-upperopen', 'upperBound()')}}</td>
   <td>{{Spec2('IndexedDB 2')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 3", "#dom-idbkeyrange-upperbound", "upperBound()")}}</td>
   <td>{{Spec2("IndexedDB 3")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBKeyRange.upperBound")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
